Interestingly, one of the most widely used JS libraries - jQuery - is dropping support for IE6/7/8 from V2.0 onwards - due for release next year (I think?). They claim that removing all of the hacks required to support these versions of IE dramatically reduces the footprint of the library and improves performance.

jQuery 1.9  will be the last version to support so-called 'legacy' IE